/* ============================================================
 * File  : channel.h
 * Author: Alvaro Gonzalez Sola <cojonuo@gmail.com>
 * Date  : 2008-08-18
 * Description :
 *
 * A generic Channel
 *
 * Copyright 2008 by Alvaro Gonzalez Sola
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published bythe Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#ifndef CHANNEL_H
#define CHANNEL_H

#include <mythtv/libmythui/mythscreentype.h>
#include <mythtv/libmythui/mythuitext.h>
#include <mythtv/libmythui/mythuitextedit.h>
#include <mythtv/libmythui/mythuibuttonlist.h>
#include <mythtv/libmythui/mythuiimage.h>
#include <mythtv/libmythui/mythdialogbox.h>
#include <mythtv/libmythui/mythprogressdialog.h>
#include <mythtv/httpcomms.h>

#include <qstring.h>
#include <QHash>
#include <qdom.h>
#include <q3urloperator.h>
#include <q3network.h>

#include "tubevideo.h"

// class TubeVideo
// {
// 
// public:
// 
//     typedef Q3PtrList<TubeVideo> List;
// 
//     TubeVideo(const QString& title, const QString& desc,
//               const QString& tubeURL, const QString& thumbnail,
//               const QString& mediaURL, const QString& enclosure,
//               const QString& date, const QString& time, 
//               const QString& rating);
//     ~TubeVideo();
// 
//     const QString& title() const { return m_title; }
//     const QString& description() const { return m_desc; }
//     const QString& tubeURL() const { return m_tubeURL; }
//     const QString& thumbnail() const { return m_thumbnail; }
//     const QString& mediaURL() const { return m_mediaURL; }
//     const QString& enclosure() const { return m_enclosure; }
//     const QString& date() const { return m_date; }
//     const QString& time() const { return m_time; }
//     const QString& rating() const { return m_rating; }
// 
//     void setEnclosure(QString enclosure) { m_enclosure = enclosure; }
// 
// private:
// 
//     QString   m_title;
//     QString   m_desc;
//     QString   m_tubeURL;
//     QString   m_thumbnail;
//     QString   m_mediaURL;
//     QString   m_enclosure;
//     QString   m_date;
//     QString   m_time;
//     QString   m_rating;
//
// };

class Channel : public QObject
{
    public:

        enum Type {
            Feed = 0,
            Search
        };

        Channel(QString name, QString url, Type type = Feed);
        ~Channel();

        QString name(){ return m_name; };
        QString url(){return m_url; };
        Type type(){ return m_type; };
        virtual QString imageURL(){ return m_imageURL; };

        TubeVideo::List& videoList() { return m_videoList; };

        void process();
        void ReplaceHtmlChar(QString &s);
        TubeVideo::List parseRSS(QDomDocument domDoc);
        TubeVideo::List parseRSS2(QDomDocument domDoc);
        TubeVideo::List parseAtom(QDomDocument domDoc);

        virtual QString channelDir (QString path = NULL);

    private:

        Type m_type;

    protected:

        QString m_destDir;

        QString m_name;
        QString m_url;

        QByteArray m_data;

        QString    m_desc;

        QString    m_imageURL;
        TubeVideo::List m_videoList;

};






#endif
