/* ============================================================
 * File  : channelscreen.h
 * Author: Alvaro Gonzalez Sola <cojonuo@gmail.com>
 * Date  : 2008-08-18
 * Description :
 *
 * Channel interface
 *
 * Copyright 2008 by Alvaro Gonzalez Sola
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published bythe Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#ifndef CHANNELSCREEN_H
#define CHANNELSCREEN_H

#include <mythtv/libmythui/mythscreentype.h>
#include <mythtv/libmythui/mythuitext.h>
#include <mythtv/libmythui/mythuitextedit.h>
#include <mythtv/libmythui/mythuibuttonlist.h>
#include <mythtv/libmythui/mythuiimage.h>
#include <mythtv/libmythui/mythdialogbox.h>
#include <mythtv/libmythui/mythprogressdialog.h>
#include <mythtv/httpcomms.h>

#include <qstring.h>
#include <QHash>
#include <q3ptrlist.h>

#include "mythtubescreen.h"
#include "feedchannel.h"

class ChannelScreen : public MythTubeScreen
{

Q_OBJECT

public:

    ChannelScreen(MythScreenStack *parent, const char *name);
    ChannelScreen(MythScreenStack *parent, const char *name, FeedChannel *channel);
    ~ChannelScreen();

    bool Create();
    bool keyPressEvent(QKeyEvent *event);
//     void downloadVideo(TubeVideo* video, QString path);
//     QString ConfDir(QString path);
    void customEvent(QEvent *event);
    void ShowMenu();
    void StreamVideo();
    void SaveVideo();
    void OpenBrowser();

private:

    //GUI elements
    MythUIButtonList *m_videoList;
    MythUIText *m_nameText;
    MythUIText *m_descText;
    MythUIText *m_titleText;
    MythUIImage *m_channelThumbnail;
    MythUIImage *m_videoThumbnail;
    MythUIImage *m_enclosureInfo;

    MythDialogBox *m_menuPopup;

    FeedChannel *m_channel;

//     void playVideo(const QString &filename);

private slots:
    void showResult(FeedChannel* channel);
    void viewVideo(MythUIButtonListItem* selected);
    void updateInfoView(MythUIButtonListItem * selected);

};

#endif
