#!/usr/bin/python
# -*- coding: utf8 -*-

#
# MiroGuide Script
#

import urllib
import sys

key = "a3cd27ee90da843fd6b49c3524ac6f7d7861674e"

def help():
   print "usage: miroguide.py [option] <argument>"
   print "     -l          \"return a list of languages\""
   print "     -c          \"return a list of categories\""
   print "     -L          \"return a list of channels\""
   print "     -C <id>     \"return a channel by <id>\""
   print "     -s <words>  \"return a list of channels search\""
   return

def parseBetween(content, tag1, tag2):

   ret = []

   part = content.partition(tag1)
   part = part[2]
   part = part.partition(tag2)
   ret.append(part[0])

   while part[2] != "":
      part = part[2].partition(tag1)
      part = part[2]
      part = part.partition(tag2)
      ret.append(part[0])

   return ret[0:-1]

def getMiroGuide(url):
   filehandle = urllib.urlopen(url)
   content = filehandle.read()
   filehandle.close()

   dicc = eval(content)

   return dicc

def getRSS(url):
   filehandle = urllib.urlopen(url)
   content = filehandle.read()
   filehandle.close()

   return content

def getLanguages():
   url = "https://www.miroguide.com/api/list_languages" + "?key=" + key

   content = getMiroGuide(url)

   for s in content:
      print s['name'].encode("utf8")
      print s['name']
   return

def getCategories():
   url = "https://www.miroguide.com/api/list_categories" + "?key=" + key

   content = getMiroGuide(url)

   for s in content:
      print s['name'].encode("utf8")
      print s['name']
   return

def getChannelByLanguage(language):

   url = "https://www.miroguide.com/api/get_channels" + "?key=" + key
   url += "&filter=language" + "&filter_value=" + language
   url += "&limit=100"

   content = getMiroGuide(url)

   for s in content:
      print s['name'].encode("utf8")
      print s['url']
      print s['description'].replace("\n","").encode("utf8");
   return

def getChannelByCategory(category):

   url = "https://www.miroguide.com/api/get_channels" + "?key=" + key
   url += "&filter=category" + "&filter_value=" + category
   url += "&limit=100"

   content = getMiroGuide(url)

   for s in content:
      print s['name'].encode("utf8")
      print s['url']
      print s['description'].encode("utf8")
   return


def getChannelList():
   url = "https://www.miroguide.com/api/get_channels" + "?key=" + key
   url += "&filter=language" + "&filter_value=Spanish"
   url += "&limit=100"

   content = getMiroGuide(url)

   for s in content:
      print s['name'], s['id']
   return

def getPopularChannels():
   url = "https://www.miroguide.com/feeds/popular"
   content = getRSS(url)

   items = parseBetween(content, "<item>", "</item>")
   for element in items:
      title = parseBetween(element, "<title>", "</title>")[0]
      description = parseBetween(element, "<description>", "</")[0]
      url1 = parseBetween(description, "url1=http%3A","&amp")[0]
      print title.strip('\n\n').encode("utf8")
      print "http:" + url1.encode("utf-8")
      print description.replace("\n", " " )
   return

def getTopRatedChannels():
   url = "https://www.miroguide.com/feeds/toprated"
   content = getRSS(url)

   items = parseBetween(content, "<item>", "</item>")
   for element in items:
      title = parseBetween(element, "<title>", "</title>")[0]
      description = parseBetween(element, "<description>", "</")[0]
      url1 = parseBetween(description, "url1=http%3A","&amp")[0]
      print title.strip('\n\n').encode("utf8")
      print "http:" + url1.encode("utf-8")
      print description.replace("\n", " " )
   return

def searchChannel(word):
   url = "https://www.miroguide.com/feeds/search/" + word
   content = getRSS(url)

   items = parseBetween(content, "<item>", "</item>")
   for element in items:
      title = parseBetween(element, "<title>", "</title>")[0]
      description = parseBetween(element, "<description>", "</")[0]
      url1 = parseBetween(description, "url1=http%3A","&amp")[0]
      print title.strip('\n\n').encode("utf8")
      print "http:" + url1.encode("utf-8")
      print description.replace("\n", " " )
   return

def getChannel(id):
   url = "https://www.miroguide.com/api/get_channel" + "?key=" + key
   url += "&id=" + id

   content = getMiroGuide(url)

   print content['name']
   print content['url']
   print content['description']

   return

def format(word):
   word = word.replace("&","%26")
   return word.replace(" ", "+" )

# MAIN

if "-h" in sys.argv:
   help()
if "-l" in sys.argv:
   getLanguages()
if "-c" in sys.argv:
   getCategories()
if "-LL" in sys.argv:
   language = sys.argv[2:]
   if len(language) > 0:
      getChannelByLanguage(format(language[0]))
if "-LC" in sys.argv:
   category = sys.argv[2:]
   if len(category) > 0:
      getChannelByCategory(format(category[0]))
if "-C" in sys.argv:
   id_index = sys.argv.index("-C") + 1
   id = sys.argv[id_index]
   getChannel(id)
if "-s" in sys.argv:
   word = sys.argv[2:]
   if len(word) > 0:
      searchChannel(format(word[0]))
if "-p" in sys.argv:
   getPopularChannels()
if "-t" in sys.argv:
   getTopRatedChannels()

sys.exit(0)


