/* ============================================================
 * File  : searchchannel.h
 * Author: Alvaro Gonzalez Sola <cojonuo@gmail.com>
 * Date  : 2008-07-30
 * Description :
 *
 * Interface to SearchScreen, provide function to search, view and manage
 * videos from video sites.
 *
 * Copyright 2008 by Alvaro Gonzalez Sola
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published bythe Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#ifndef SEARCHSCREEN_H
#define SEARCHSCREEN_H

#include <mythtv/libmythui/mythscreentype.h>
#include <mythtv/libmythui/mythuitext.h>
#include <mythtv/libmythui/mythuitextedit.h>
#include <mythtv/libmythui/mythuibuttonlist.h>
#include <mythtv/libmythui/mythuiimage.h>
#include <mythtv/libmythui/mythdialogbox.h>
#include <mythtv/libmythui/mythprogressdialog.h>
#include <mythtv/httpcomms.h>

#include <qstring.h>
#include <QHash>

#include "tubevideo.h"
#include "mythtubescreen.h"

class SearchScreen : public MythTubeScreen
{

Q_OBJECT

public:

//     enum VideoMode {
//         DOWNLOAD = 0,
//         STREAM,
//         SAVE
//     };

    typedef QHash<QString, QString> VideoCache;

    SearchScreen(MythScreenStack *parent, const char *name);
    ~SearchScreen();

    bool Create();
    bool keyPressEvent(QKeyEvent *event);
    void customEvent(QEvent*);

private:

    //Search engine
    Search *search;

    //GUI elements
    MythUITextEdit *m_queryEdit;
    MythUIButton *m_searchButton;
    MythUIButtonList *m_videoList;
    MythUIButtonList *m_siteList;
    MythUIText *m_infoText;
    MythUIText *m_timeText;
    MythUIText *m_dateText;
    MythUIText *m_ratingText;
    MythUIImage *m_thumbnailImage;
    MythDialogBox *m_menuPopup;

//     VideoMode m_mode;

/* OLD CODE
//     MythDialogBox *m_infoPopup;
//     MythUIProgressDialog *m_progressPopup;

    //Video cache
//
//  OLD CODE
//
//     VideoCache cache;
//     int cacheSize;
//     int cacheIndex;

    //Download video elements

// OLD CODE (REVISE)
//
//     HttpComms      *httpGrabber;
//     bool           abortHttp;
*/
/* OLD CODE
// OLD CODE (REVISE)
//
//     void createProgress(QString title);
//     bool getHttpFile(QString sFilename, QString cmdURL);
//     void downloadVideo(TubeVideo* video, QString path);
//     void playVideo(const QString &filename);
//     QString ConfDir(QString path);
//     void ShowInfo(QString message);
*/

    void getSitesScript();
    void ShowMenu();
    void StreamVideo();
    void SaveVideo();

private slots:

    void slotSearch(void);
    void showResult(Search* search);
    void updateInfoView(MythUIButtonListItem* selected);
    void selectVideo(MythUIButtonListItem* selected);
    void slotViewVideo(TubeVideo* video);

};

#endif
